package client.mid1;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.microedition.lcdui.StringItem;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import client.ws.Contact;

import com.agiledelta.efx.EFXException;
import com.agiledelta.efx.EFXStreamReader;
import com.agiledelta.efx.microedition.EFXFactory;

public class Processing implements Runnable {

	EFXFactory efx1;
	SonyMidlet par;
	
	public Processing(EFXFactory efx, SonyMidlet mi){
		par=mi;
		efx1=efx;
	}
	
	
	private void processingControl(String name){
		try {	
		
		InputStream is1 = getClass().getResourceAsStream("/data/pros/"+name+".xml");
		byte[] xml= new byte[is1.available()];
		is1.read(xml);
		is1.close();
		

		
		String efxT="EFX times in ms:", plainT="Plain times in ms:";
		int number=10;
		long efxTime=0,plainTime=0;
		

		InputStream is2 = getClass().getResourceAsStream("/data/pros/"+name+".xml.efx");
		byte[] efx= new byte[is2.available()];
		is2.read(efx);
		is2.close();		
		
		
		for(int i=0; i<number;i++){
			
		
		long startEfx=System.currentTimeMillis();	
		efxPros(efx);
		long stopEfx=System.currentTimeMillis();	
		
		long startPlain=System.currentTimeMillis();	
		plainPros(xml);
		long stopPlain=System.currentTimeMillis();	

		//efxT=efxT+"	"+Long.toString(stopEfx-startEfx);
		efxTime=efxTime+(stopEfx-startEfx);
		//plainT=plainT+"	"+Long.toString(stopPlain-startPlain);
		plainTime=plainTime+(stopPlain-startPlain);
		}
		
		efxT=efxT+"	average: "+Long.toString(efxTime/number);
		plainT=plainT+"	average: "+Long.toString(plainTime/number);
		par.setTimePros(name, plainT, efxT);
		System.out.println(name);
		System.out.println(plainT);
		System.out.println(efxT);
		
		
		/*System.out.println(name);
		System.out.println("time efx: "+String.valueOf(stopEfx-startEfx) );
		System.out.println("time plain: "+String.valueOf(stopPlain-startPlain) );
		*/
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	

	
	private void efxPros(byte[] efx){
		
		ByteArrayInputStream bais=null;
		EFXStreamReader readEfx;
		
		try{
			bais = new ByteArrayInputStream(efx);
		}catch(Exception e){
			e.printStackTrace();
		}

		
		try {
			readEfx = efx1.createEFXStreamReader(bais);
			readEfx.next(EFXStreamReader.START_ELEMENT);
			readEfx.next(EFXStreamReader.START_ELEMENT);
			//starts the measurements of the prossesing
							
			boolean hasMore=true;
			while(hasMore){
					//System.out.println("starter efx lokke");
				Contact temp = new Contact();						
				//if(readEfx.next()==EFXStreamReader.START_ELEMENT){
				//readEfx.next(EFXStreamReader.START_ELEMENT); // <contact>
				readEfx.next(EFXStreamReader.CHARACTERS);
				temp.setFirstName(readEfx.getString());
				//System.out.println(readEfx.getString());
				readEfx.next(EFXStreamReader.START_ELEMENT);
				readEfx.next(EFXStreamReader.CHARACTERS);
				temp.setLastName(readEfx.getString());
				//System.out.println(readEfx.getString());
				readEfx.next(EFXStreamReader.START_ELEMENT);
                readEfx.next(EFXStreamReader.CHARACTERS);
                temp.setPhoneNumber(Integer.parseInt(readEfx.getString()));
                //System.out.println(readEfx.getString());
                readEfx.next(EFXStreamReader.START_ELEMENT);
                readEfx.next(EFXStreamReader.CHARACTERS);
                temp.setEMail(readEfx.getString());
                //System.out.println(readEfx.getString());
                readEfx.next(EFXStreamReader.START_ELEMENT);
                readEfx.next(EFXStreamReader.CHARACTERS);
                temp.setAddress(readEfx.getString());
                //System.out.println(readEfx.getString());
                readEfx.next(EFXStreamReader.START_ELEMENT);
                readEfx.next(EFXStreamReader.CHARACTERS);
                temp.setPostalCode(Integer.parseInt(readEfx.getString()));
                //System.out.println(readEfx.getString());	              
                readEfx.next(EFXStreamReader.START_ELEMENT);
                readEfx.next(EFXStreamReader.CHARACTERS);
                temp.setTown(readEfx.getString());
               // System.out.println(readEfx.getString());	        
                readEfx.next(EFXStreamReader.END_ELEMENT);
                readEfx.next(EFXStreamReader.END_ELEMENT);
				//}
				if(readEfx.next()==EFXStreamReader.END_ELEMENT){
					hasMore=false;
				}	
//				this.resScreen.addEntry(temp);	
			}

			
			bais.close();

			//System.out.println(readEfx.getQName());

		} catch (EFXException e1) {

			e1.printStackTrace();
		} catch (IOException e1) {

			e1.printStackTrace();
		}
	}
	
	private void plainPros(byte[] pla){
		try {
			//plainBytes = Base64Coder.decode(plain);
			ByteArrayInputStream bais = new ByteArrayInputStream(pla);
			SAXParserFactory fac = SAXParserFactory.newInstance();
			
			SAXParser saxP =fac.newSAXParser();
			
			//long start = System.currentTimeMillis();
			saxP.parse(bais, new ContactHandlerPros());
			//long stop = System.currentTimeMillis();
			bais.close();

			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	
	public void run() {
		this.processingControl("Fredrik");
		this.processingControl("Anne");
		this.processingControl("Lars");
		this.processingControl("Elin");
		this.processingControl("Jostein");
		this.processingControl("Susanne");
		this.processingControl("Harald");
		this.processingControl("Kristin");
		this.processingControl("Trine");
		this.processingControl("Marianne");
		this.processingControl("Mathias");
		this.processingControl("Ida");
		this.processingControl("Per");
		this.processingControl("Ole");
		par.d.setCurrent(par.resScreen);
		// TODO Auto-generated method stub

	}

}
