package client.mid1;


import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.rmi.RemoteException;
import java.util.Date;

import javax.microedition.lcdui.StringItem;

import com.agiledelta.efx.EFXException;
import com.agiledelta.efx.EFXStreamReader;
import com.agiledelta.efx.microedition.EFXFactory;
import com.sun.midp.io.Base64;

import client.ws.AddressBook1PortType_Stub;
import client.ws.ContactBook;


public class WsThread implements Runnable {

	protected AddressBook1PortType_Stub wsStub;
	protected ContactBook book;
	protected String name;
	protected SonyMidlet parent;
	protected int type, testNumber;
	protected EFXFactory efx;
	protected String testResults="\r\n\r\n"+ new Date().toString()+"\r\n \r\n";
	
	
	public static final int PLAIN=1;
	public static final int PLAIN_STRING=2;
	public static final int ZLIB=3;
	public static final int EFX=4;
	public static final int EFX_ZIP=5;
	public static final int TEST=9;
	
	public WsThread(SonyMidlet mid){
		//this.name = name;
		parent = mid;
		testNumber=9;
		wsStub = new AddressBook1PortType_Stub();
		try {
			efx = EFXFactory.newInstance();
		} catch (EFXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		book = new ContactBook();
		
	}
	
	public void setName(String name){
		this.name = name;
	}
	public void setType(int type){
		this.type=type;
	}
	
	public void preapere(String name, int type){
		this.name=name;
		this.type=type;
	}
	
	private void decodeEfx(String base64){

	
	}
	
	
	
	public void run() {
		System.out.println("start " + name);
		long startT = 0;
		long stopT= 0;
		String result="";
		
		try {
			
			if(type==PLAIN){
				startT = System.currentTimeMillis();
				book.setContacts(wsStub.getNumberPlain(name));
				stopT = System.currentTimeMillis();
			}
			else if (type==PLAIN_STRING){
				startT = System.currentTimeMillis();
				result= wsStub.getNumberPlainAsString(name);
				//System.out.println();
				stopT = System.currentTimeMillis();
				//parent.setRetTime(stopT-startT);
				
				this.parent.updatePlainAsString(result, stopT-startT, name);
			}
			else if(type==ZLIB){
				startT = System.currentTimeMillis();
				result=wsStub.getNumberZlibAsString(name);
				//System.out.println();
				stopT = System.currentTimeMillis();
				this.parent.updateZlib(result, stopT-startT, name);
			}
			else if(type==EFX){
				startT = System.currentTimeMillis();
				result =wsStub.getNumberEfxAsString(name);
				
				//System.out.println();
				stopT = System.currentTimeMillis();
				//parent.setRetTime(stopT-startT);
				this.parent.updateEfx(result, stopT-startT, name);
				
				//decodeEfx(result);
			}
			else if(type==EFX_ZIP){
				startT = System.currentTimeMillis();
				result =wsStub.getNumberEfxAndZlibAsString(name);
				stopT = System.currentTimeMillis();

				this.parent.updateEfxAndZip(result, stopT-startT, name);
			}
			else if(type==TEST){
				test(3);
			}
			
			
			
			System.out.println("tid: "+String.valueOf(stopT-startT)+"ms"+" antall bytes "+ result.getBytes().length);
			
			
			//System.out.println("kommer hit");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//System.out.println(number);
		if(parent != null){
			
			//parent.setResults(result, type, stopT-startT);
			//parent.setNumber(book);
		}
	
	}
	
	private void test(int antall){
		try {
			wsStub.getNumberEfxAsString("Lars");
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		testName("Fredrik", antall);
		testName("Anne", antall);
		testName("Lars", antall);
		testName("Elin", antall);
		testName("Jostein", antall);
		testName("Susanne", antall);
		testName("Harald", antall);
		testName("Kristin", antall);
		testName("Trine", antall);
		testName("Marianne", antall);
		testName("Mathias", antall);
		testName("Ida", antall);
		testName("Per", antall);
		//testName("Ole", antall);
		
		
		parent.setTest(testResults);

	}
	
	private void testName(String name, int times){
		long startT, stopT;
		long plainT=0;
		long zlibT=0;
		long efxT=0;
		long efxZipT=0;
		String result;
		int zlibS=0,plainS=0,efxS=0,efxzipS=0;
		
		testResults=testResults+name+"\r\n\r\n";
		try {
		
		for(int i=0; i<times; i++){
			Thread.sleep(1000);
			//System.out.println();
			
			//PLAIN
			startT = System.currentTimeMillis();

				result= wsStub.getNumberPlainAsString(name);

			//System.out.println();
			stopT = System.currentTimeMillis();
			plainT+=stopT-startT;
			testResults=testResults+"PLAIN:			"+String.valueOf(stopT-startT)+" ms"+"\r\n";
			if(i==0){
				plainS=result.length();
			}
			//results[i]=name+" Plain "+String.valueOf(stopT-startT)+" ms";
			//this.parent.resScreen.append(new StringItem(name, " plain time: "+String.valueOf(stopT-startT)+" ms"));
			
			//System.out.println("Plain "+String.valueOf(stopT-startT)+" ms");
			
			//ZLIB
			startT = System.currentTimeMillis();
			result=wsStub.getNumberZlibAsString(name);
			//System.out.println();
			stopT = System.currentTimeMillis();
			zlibT+= stopT-startT;
			testResults=testResults+"ZLIB:		"+String.valueOf(stopT-startT)+" ms"+"\r\n";
			if(i==0){
				zlibS=result.length();
			}
			
			//results[i+1]=name+" Zlib "+String.valueOf(stopT-startT)+" ms";
			//System.out.println("ZLIB "+String.valueOf(stopT-startT)+" ms");
			//this.parent.resScreen.append(new StringItem(name, " zlib time: "+String.valueOf(stopT-startT)+" ms"));
			
			//EFX
			startT = System.currentTimeMillis();
			result =wsStub.getNumberEfxAsString(name);
			//System.out.println();
			stopT = System.currentTimeMillis();
			efxT+=stopT-startT;
			testResults=testResults+"EFX:		"+String.valueOf(stopT-startT)+" ms"+"\r\n";
			if(i==0){
				efxS=result.length();
			}
			//this.parent.resScreen.append(new StringItem(name, " efx time: "+String.valueOf(stopT-startT)+" ms"));
			//results[i+2]=name+" Efx "+String.valueOf(stopT-startT)+" ms";
			//System.out.println("EFX "+String.valueOf(stopT-startT)+" ms");
			
			//EFX_ZIP
			startT = System.currentTimeMillis();
			result =wsStub.getNumberEfxAndZlibAsString(name);
			//System.out.println();
			stopT = System.currentTimeMillis();
			efxZipT+=stopT-startT;
			testResults=testResults+"EFX_ZIP:	"+String.valueOf(stopT-startT)+" ms"+"\r\n";
			if(i==0){
				efxzipS=result.length();
			}
			//this.parent.resScreen.append(new StringItem(name, " efx and zip time: "+String.valueOf(stopT-startT)+" ms"));
			//results[i+2]=name+" EfxAndZip "+String.valueOf(stopT-startT)+" ms";
			//System.out.println("EFX_ZIP "+String.valueOf(stopT-startT)+" ms");
			


		
	}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	

		testResults=testResults+"\r\nAVERAGE: \r\n";
			long avg, avgz, avge, avgez;
			avg=plainT/times;
			System.out.println(name);
			System.out.println("		Plain "+avg);
			testResults=testResults+"	PLAIN:		"+String.valueOf(avg)+" ms	"+plainS+"	bytes"+"\r\n";
			plainT=0;
			avgz=zlibT/times;
			testResults=testResults+"	ZLIB:		"+String.valueOf(avgz)+" ms	"+zlibS+"	bytes"+"\r\n";
			System.out.println("		ZLIB "+avgz);
			zlibT=0;
			avge=efxT/times;
			testResults=testResults+"	EFX:		"+String.valueOf(avge)+" ms	"+efxS+"	bytes"+"\r\n";
			System.out.println("		EFX "+avge);
			efxT=0;
			avgez=efxZipT/times;
			testResults=testResults+"	EFX_ZIP:	"+String.valueOf(avgez)+" ms	"+efxzipS+"	bytes"+"\r\n";
			System.out.println("		EFX_ZIP "+avgez);
			efxZipT=0;
			this.parent.resScreen.append(new StringItem(name, " AVG. plain: "+String.valueOf(avg)+" ms"+" zlib: "+String.valueOf(avgz)+" efx: "+String.valueOf(avge))+" efxZip: "+String.valueOf(avgez));
			name="Per";
	
			testResults=testResults+"\r\n\r\n";
	}
			
	
	

}
